<?php

/**
 * liquidacion_cierre_anu_1 actions.
 *
 * @package    canon
 * @subpackage liquidacion_cierre_anu_1
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class liquidacion_cierre_anu_1Actions extends sfQuery
{
  /**
     * Executes index action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {


        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejo de errores
         */
        try {
            
            //Session de fecha
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"    
EOD;
            //ejecuta sql
            CN_TABLE::executeSQL($sql);


            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 75;
            }

            /*
             * variables de filtro
             */
            $id_plan_not = '';
            if (isset($request['id_plan_not'])) {
                $id_plan_not = "'" . $request['id_plan_not'] . "' ";
            }
       

            if ($id_plan_not == '') {
                throw new Exception("Los parámetros obligatorios no fueron enviados");
                exit();
            }

            
            $fecha_actual = CN_TABLE::fechaSistema();
            $vigencia_actual = date('Y');
            //Cerrar planilla
             $sql = <<<EOD
            
UPDATE CA_PLAN_NOT
SET estado             = 0,
    fecha_notificacion = to_date('$fecha_actual', 'YYYY-MM-DD')       
WHERE ID_PLAN_NOT      = $id_plan_not

EOD;

            CN_TABLE::executeSQL($sql);
            
            
            //Crear recibos
           
            
            //Crea todos los recibos de una planilla
            $sql = <<<EOD
INSERT INTO CA_RECIBO_SOLICITUD
  (
    ID_RECIBO_SOLICITUD,
    COD_EXPEDIENTE,
    ID_MODALIDAD,
    ID_ETAPA,
    VALOR,
    FECHA_EXPED_REC,
    FECHA_VENCE_REC,
    FECHA_NOTIFICACION,
    PAGO,
    CANON,
    AREA,
    VIGENCIA,
    NUM_RECIBO,
    ID_DET_PLAN_NOT,
    ID_SMDLV, 
    ID_NORMA        
  )
(select 
null as id_rec,
tab1.codigo_expediente, 
tab1.id_modalidad, 
tab2.id_etapa, 
null as valor, 
to_date('$fecha_actual', 'yyyy-mm-dd')  as fecha_exped, 
dias_habiles(to_date('$fecha_actual','yyyy-mm-dd'), 3)  as fecha_vence, 
(select fecha_notificacion from ca_plan_not where id_plan_not=$id_plan_not) as fecha_not, 
0 as pago, 
0 as canon, 

case 
when tab1.area_definitiva is not null then tab1.area_definitiva
when tab0.area is not null then tab0.area
end as area_definitiva,

(select vigencia from ca_plan_not where id_plan_not=$id_plan_not) as vigencia,
(select nvl(max(num_recibo),0) from ca_recibo_solicitud)+rownum as num_recibo, 
tab0.id_det_plan_not, 
(select id_smdlv from ca_smdlv where vigencia=(select vigencia from ca_plan_not where id_plan_not=$id_plan_not)) as id_smdlv,
tab0.id_norma

from  
ca_det_plan_not tab0 
join rmn_solicitud tab1 on tab0.cod_exp=tab1.codigo_expediente 
join ca_etapa_modalidad tab2 on tab1.id_modalidad=tab2.id_modalidad
join ca_tipo_tramite tab3 on tab0.id_tipo_tramite=tab3.id_tipo_tramite

where 1=1 and tab0.id_plan_not=$id_plan_not and tab3.notifica=1 and tab3.estado=1 and tab2.orden=1 )
EOD;

             CN_TABLE::executeSQL($sql);
       
            //Operaciones: 1-CONSULTAR, 2-ACTUALIZAR, 3-ADICIONAR, 4-ELIMINAR, 5-ANULAR
            $id_ope_bd = 3;
            //obtener id maestro tabla
            $id_mae_bd = CN_TABLE::consultarIdTablaBD('ca_recibo_solicitud');
            //registro de consulta en tabla de log- la observacion puede o no enviarse ($request, $id_ope_bd, $id_mae_bd, $observacion)
            $sql = CN_TABLE::registrarLog($request, $id_ope_bd, $id_mae_bd, "Se cerro una liquidación de la primera anualidad desde el notificador");

             /*
             * Obtiene los accesos para un perfil
             */
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (
      
select tab0.*, tab1.valor_mensual, tab2.formula, 1 as anualidad 
from ca_recibo_solicitud tab0 
join ca_smdlv tab1 on tab0.id_smdlv=tab1.id_smdlv
join ca_formula tab2 on tab0.id_etapa=tab2.id_etapa and tab0.id_norma=tab2.id_norma
join ca_det_plan_not tab3 on tab0.id_det_plan_not=tab3.id_det_plan_not
join ca_plan_not tab4 on tab3.id_plan_not=tab4.id_plan_not

where tab4.id_plan_not=$id_plan_not

                        
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;

            //ejecuta y obtiene el resultado del sql
            $recs = CN_TABLE::executeSQL($sql);

            $cant = count($recs);
            
            
            $this->totalRows = $cant;
            $this->startRow = $rowStart;
            $this->endRow = $rowEnd;
            $this->status = 0;
            $this->list_data = $recs;
            $this->logMessage("[LIQUIDACION_CIERRE_ANU_1] Generación exitosa recibos anualidad 1.");
            
        } catch (Exception $e) {

            $this->status = 1;
            $this->mensajeError = "ERROR!!! ".$e->getMessage();
            $this->list_data = array();
            $this->logMessage("Error: " . $e->getMessage());
        }
    }
    
     /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

 
        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
